local Gem = GemSocketsAddon;
local sockets = Gem.sockets;
local hovered = false;
local hover = false;

infos = 
    {
        [1] = { ["name"] = "CharacterHeadSlot"},
        [2] = { ["name"] = "CharacterNeckSlot"},
        [3] = { ["name"] = "CharacterShoulderSlot"},
        [4] = { ["name"] = "CharacterShirtSlot"},
        [5] = { ["name"] = "CharacterChestSlot"},
        [6] = { ["name"] = "CharacterWaistSlot"},
        [7] = { ["name"] = "CharacterLegsSlot"},
        [8] = { ["name"] = "CharacterFeetSlot"},
        [9] = { ["name"] = "CharacterWristSlot"},
        [10] = { ["name"] = "CharacterHandsSlot"},
        [11] = { ["name"] = "CharacterFinger0Slot"},
        [12] = { ["name"] = "CharacterFinger1Slot"},
        [13] = { ["name"] = "CharacterTrinket0Slot"},
        [14] = { ["name"] = "CharacterTrinket1Slot"},
        [15] = { ["name"] = "CharacterBackSlot"},
        [16] = { ["name"] = "CharacterMainHandSlot"},
        [17] = { ["name"] = "CharacterSecondaryHandSlot"},
        [19] = { ["name"] = "CharacterTabardSlot"}
    };


function sockets.showGameTooltip(self, motion)
    hovered = self.name;
    if self.link then
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        GameTooltip:SetHyperlink(self.link);
        GameTooltip:Show();
    end
end

function sockets.hideGameTooltip(self, motion)
    GameTooltip:Hide();
end

function sockets.setTooltip() 
    gemType = 
        {
            [1] = { ["name"] = "Deadly Lava Lazuli" },
            [2] = { ["name"] = "Quick Sand Spinel" },
            [3] = { ["name"] = "Masterful Sea Currant" },
            [4] = { ["name"] = "Versatile Dark Opal" }
        };
    local red = UseContainerItemByName("Deadly Lava Lazuli", 0);
    local yellow = UseContainerItemByName("Quick Sand Spinel", 0);
    local purple = UseContainerItemByName("Masterful Sea Currant", 0);
    local blue = UseContainerItemByName("Versatile Dark Opal", 0);
    

    for id, item in pairs(infos) do
        --print(id.." -> "..item.name);
        frame = _G[item.name];
        itemLink = GetInventoryItemLink("player", id)

        frame.link = itemLink;
        frame:SetScript("OnEnter", sockets.showGameTooltip);
        frame:SetScript("OnLeave", sockets.hideGameTooltip);

        i = 0;
        canGem = false;
        for text in itemLink:gmatch("(.-):") do
            i = i + 1
            if i == 4 then
                if text ~= "" then
                    canGem = true;
                end
            end
        end
        
        if canGem then
            local f1 = CreateFrame("Button",nil,frame)
            local f2 = CreateFrame("Button",nil,frame)
            local f3 = CreateFrame("Button",nil,frame)
            local f4 = CreateFrame("Button",nil,frame)
            local lastFrame = frame;
            --Crit
            if red ~= false then
                f1:SetWidth(50);
                f1:SetHeight(frame:GetHeight());
                
                local t = f1:CreateTexture(nil,"OVERLAY")
                t:SetTexture("629170")
                t:SetAllPoints(f1)
                f1.texture = t
                
                f1:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
                lastFrame = f1;
            end
            if yellow ~= false then
                --Haste
                f2:SetWidth(50);
                f2:SetHeight(frame:GetHeight());
                
                local t = f2:CreateTexture(nil,"OVERLAY")
                t:SetTexture("629173")
                t:SetAllPoints(f2)
                f2.texture = t
                
                f2:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);      
                lastFrame = f2;
            end
            if purple ~= false then
                --Mastery
                f3:SetWidth(50);
                f3:SetHeight(frame:GetHeight());
                local t = f3:CreateTexture(nil,"OVERLAY")
                t:SetTexture("629171")
                t:SetAllPoints(f3)
                f3.texture = t
                
                f3:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
                lastFrame = f3;
            end
            if blue ~= false then
                --Versa
                f4:SetWidth(50);
                f4:SetHeight(frame:GetHeight());
                
                local t = f4:CreateTexture(nil,"OVERLAY")
                t:SetTexture("629168")
                t:SetAllPoints(f4)
                f4.texture = t
                
                f4:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
                lastFrame = f4;
            end

            f1:Hide()
            f2:Hide()
            f3:Hide()
            f4:Hide()

            frame.f1 = f1;
            frame.f2 = f2;
            frame.f3 = f3;
            frame.f4 = f4;
            frame.name = item.name;
            frame.link = itemLink;
            frame:SetScript("OnEnter", sockets.showGemsEnter);
            frame:SetScript("OnUpdate", sockets.showGemsUpdate);
            frame:SetScript("OnLeave", sockets.showGemsLeave);
            
            --Crit
            f1.name = item.name;
            f1.link = "\124cffa335ee\124Hitem:168639::::::::120:::::\124h[Deadly Lava Lazuli]\124h\124r"
            f1:SetScript("OnEnter", sockets.showGameTooltip);
            f1:SetScript("OnLeave", sockets.hideGameTooltip);
            f1:SetScript("OnClick", function (self, button, down)
                local name = "Deadly Lava Lazuli";
                bag = UseContainerItemByName(name, 0);
                slot = UseContainerItemByName(name, 1);
                if bag ~= false and slot ~= false then
                    SocketInventoryItem(id);
                    PickupContainerItem(bag, slot);
                    ClickSocketButton(1);
                    AcceptSockets();
                    CloseSocketInfo();
                end    
            end);
            --Haste
            f2.name = item.name;
            f2.link = "\124cffa335ee\124Hitem:168641::::::::120:::::\124h[Quick Sand Spinel]\124h\124r"
            f2:SetScript("OnEnter", sockets.showGameTooltip);
            f2:SetScript("OnLeave", sockets.hideGameTooltip);
            f2:SetScript("OnClick", function (self, button, down)
                local name = "Quick Sand Spinel";         
                bag = UseContainerItemByName(name, 0);
                slot = UseContainerItemByName(name, 1);
                if bag ~= false and slot ~= false then
                    SocketInventoryItem(id);
                    PickupContainerItem(bag, slot);
                    ClickSocketButton(1);
                    AcceptSockets();
                    CloseSocketInfo();
                end
            end);
            --Mastery
            f3.name = item.name;
            f3.link = "\124cffa335ee\124Hitem:168640::::::::120:::::\124h[Masterful Sea Currant]\124h\124r"
            f3:SetScript("OnEnter", sockets.showGameTooltip);
            f3:SetScript("OnLeave", sockets.hideGameTooltip);
            f3:SetScript("OnClick", function (self, button, down)
                local name = "Masterful Sea Currant";         
                bag = UseContainerItemByName(name, 0);
                slot = UseContainerItemByName(name, 1);
                if bag ~= false and slot ~= false then
                    SocketInventoryItem(id);
                    PickupContainerItem(bag, slot);
                    ClickSocketButton(1);
                    AcceptSockets();
                    CloseSocketInfo();
                end
            end);
            --Versa
            f4.name = item.name;
            f4.link = "\124cffa335ee\124Hitem:168642::::::::120:::::\124h[Versatile Dark Opal]\124h\124r"
            f4:SetScript("OnEnter", sockets.showGameTooltip);
            f4:SetScript("OnLeave", sockets.hideGameTooltip);
            f4:SetScript("OnClick", function (self, button, down)
                local name = "Versatile Dark Opal";         
                bag = UseContainerItemByName(name, 0);
                slot = UseContainerItemByName(name, 1);
                if bag ~= false and slot ~= false then
                    SocketInventoryItem(id);
                    PickupContainerItem(bag, slot);
                    ClickSocketButton(1);
                    AcceptSockets();
                    CloseSocketInfo();
                end
            end);
        end
    end
end

function sockets.showGemsEnter(self, motion)
    hovered = self.name;
    hover = true
    if self.link then
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        GameTooltip:SetHyperlink(self.link);
        GameTooltip:Show();
    end
end

function sockets.showGemsLeave(self, motion)
    hovered = false;
    GameTooltip:Hide();
end


function sockets.showGemsUpdate(self, motion)
    if ( IsShiftKeyDown() and hovered == self.name) then 
        if hover then
            GameTooltip:Hide();
            hover = false;
        end
        local lastFrame = self;
        local red = UseContainerItemByName("Deadly Lava Lazuli", 0);
        local yellow = UseContainerItemByName("Quick Sand Spinel", 0);
        local purple = UseContainerItemByName("Masterful Sea Currant", 0);
        local blue = UseContainerItemByName("Versatile Dark Opal", 0);
        --Crit
        if red ~= false then
            self.f1:SetWidth(50);
            self.f1:SetHeight(frame:GetHeight());
            
            local t = self.f1:CreateTexture(nil,"OVERLAY")
            t:SetTexture("629170")
            t:SetAllPoints(self.f1)
            self.f1.texture = t
            
            self.f1:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
            lastFrame = self.f1;
        end
        if yellow ~= false then
            --Haste
            self.f2:SetWidth(50);
            self.f2:SetHeight(frame:GetHeight());
            
            local t = self.f2:CreateTexture(nil,"OVERLAY")
            t:SetTexture("629173")
            t:SetAllPoints(self.f2)
            self.f2.texture = t
            
            self.f2:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);      
            lastFrame = self.f2;
        end
        if purple ~= false then
            --Mastery
            self.f3:SetWidth(50);
            self.f3:SetHeight(frame:GetHeight());
            local t = self.f3:CreateTexture(nil,"OVERLAY")
            t:SetTexture("629171")
            t:SetAllPoints(self.f3)
            self.f3.texture = t
            
            self.f3:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
            lastFrame = self.f3;
        end
        if blue ~= false then
            --Versa
            self.f4:SetWidth(50);
            self.f4:SetHeight(frame:GetHeight());
            
            local t = self.f4:CreateTexture(nil,"OVERLAY")
            t:SetTexture("629168")
            t:SetAllPoints(self.f4)
            self.f4.texture = t
            
            self.f4:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", lastFrame:GetWidth(), 0);
            lastFrame = self.f4;
        end

        if red ~= false then
            self.f1:Show()
        end
        if yellow ~= false then
            self.f2:Show()
        end
        if purple ~= false then
            self.f3:Show()
        end
        if blue ~= false then
            self.f4:Show()
        end
    else 
        self.f1:Hide()
        self.f2:Hide()
        self.f3:Hide()
        self.f4:Hide()
    end
end

function UseContainerItemByName(search, xy)
    for bag = 0,4 do
      for slot = 1,GetContainerNumSlots(bag) do
        local item = GetContainerItemLink(bag,slot)
        if item and item:find(search) then
            if xy == 0 then
                return bag;
            end
            if xy == 1 then
                return slot;
            end
        end
      end
    end
    return false;
  end

function sockets:init()
    C_Timer.After(30, function()
        sockets.setTooltip();
    end)
end
